// DashedView.h : interface of the CDashedView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DASHEDVIEW_H__4651F81E_870A_11D2_B58C_000000000000__INCLUDED_)
#define AFX_DASHEDVIEW_H__4651F81E_870A_11D2_B58C_000000000000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CDashedView : public CView
{
protected: // create from serialization only
	CDashedView();
	DECLARE_DYNCREATE(CDashedView)

// Attributes
public:
	CDashedDoc* GetDocument();
	void RecreateEllipse();
	void UpdateEllipseRgn(CDC* pDC);
	void DrawPathOutline(const COLORREF& c, CDC& dc);
	void RotateEllipse();
private:
	bool		m_Round;
	bool		m_Rotate;
	unsigned	m_PenSize;
	double		m_Radians;
	CPoint		m_EllipsePts[13];
	CRect		m_EllipseRect;
	CRgn		m_EllipseRgn;
	CRgn		m_EllipseFillRgn;


// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDashedView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDashedView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CDashedView)
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnDestroy();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnIncreasewidth();
	afx_msg void OnDecreasewidth();
	afx_msg void OnRotate();
	afx_msg void OnUpdateRotate(CCmdUI* pCmdUI);
	afx_msg void OnRound();
	afx_msg void OnUpdateRound(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

void VerticalGradientFill(const CRect& r, CDC& dc);
void RotatePoints(double radians, const CPoint& c, CPoint* vCtlPt, unsigned Cnt);

#ifndef _DEBUG  // debug version in DashedView.cpp
inline CDashedDoc* CDashedView::GetDocument()
   { return (CDashedDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DASHEDVIEW_H__4651F81E_870A_11D2_B58C_000000000000__INCLUDED_)
